
import globs
from globs import *


class BattleCamp:
    def __init__(self):
        self.ready    = False
        self.scrolled = False
        self.lastupdated = 0.0

        self.mainchoords   = 0
        self.subchoords    = [0,0]
        self.specifchoords = [0,0]

        self.mainmen  = True
        self.equipmen = False
        self.specmen  = False
        self.itemmen  = False
        self.showmap  = False

        self.specific     = False
        self.gearscrolled = False

        self.gear_dict = {}

        
        


    def scroll(self):
        self.game_state = globs.Surface.copy()
        now = globs.Surface.copy(); where = 0
        while 1:
            if pygame.time.get_ticks() - self.lastupdated > 1000/65:
                where += 5
                globs.Surface.fill((0,0,0,0))
                globs.Surface.blit(self.page,((1200-where),0))                   
                globs.Surface.blit(now,(-5,0))
                pygame.display.update()
                now = globs.Surface.copy()
                if where == 1000: break
                self.lasupdated = pygame.time.get_ticks()
        self.scrolled = True
        pygame.event.clear() ##
        #event que is cleared after scrolling to avoid possible keyerrors.
        #This problem could also be solved with an exception handler perhaps more elegantly but more difficultly.
        #Previously a player could preemptively key in events while scrolling which was nice...  but a miss key or
        #keying to rapidly could cause an exception.
        #By clearing the event cue this problem is avoided, but pre-keying is now impossible.

        

    def setitup(self):
        self.page = pygame.Surface((1000,700)).convert_alpha()
        self.page.fill((0,0,0,0))
        self.page.blit(graphic["campscreen"],(0,0))
        
        self.shrink_player()
        self.page.fill(globs.Level.mapped["background"]["colour"],(30,50,400,400))
        self.page.blit(self.player_image,(30,50))

        self.draw_equips(self.page,(465,390))
        self.print_stats(self.page,645)

        self.ready = True

    def shrink_player(self):
        self.player_image = pygame.transform.scale(globs.Player.image,(400,400))
        
    def draw_equips(self,surface,where):
        equippy = pygame.Surface((250,50)).convert()
        equippy.fill((0,0,0,0))
        #the 'for' method works but the order is arbitrary and I don't have faith it won't
        #randomly change.
##        for i,part in enumerate(globs.Player.equipped):
##            equippy.blit(globs.Player.equipped[part].display[0],(i*50,0))
        equippy.blit(globs.Player.equipped["body"].display[0],(0*50,0))
        equippy.blit(globs.Player.equipped["head"].display[0],(1*50,0))
        equippy.blit(globs.Player.equipped["armleg"].display[0],(2*50,0))
        equippy.blit(globs.Player.equipped["weapon"].display[0],(3*50,0))
        equippy.blit(globs.Player.equipped["shield"].display[0],(4*50,0))
        equippy.set_colorkey((255,0,255))
        surface.blit(equippy,where)

    def print_stats(self,surface,xwhere):
        surface.blit(basicFont.render(str(globs.Player.defense),0,(0,0,255)),(xwhere,115))
        surface.blit(basicFont.render(str(globs.Player.weapon.atk),0,(0,0,255)),(xwhere,175))
        surface.blit(basicFont.render(str(globs.Player.speed),0,(0,0,255)),(xwhere,235))
        
        
                                   
    def update(self):
        if self.gearscrolled == False:
            globs.Surface.blit(graphic["campscreen"],(200,0))
            self.draw_equips(globs.Surface,(665,390))
            self.print_stats(globs.Surface,845)
        if self.mainmen:
            pygame.draw.rect(globs.Surface,(255,0,0),(480,482+50*self.mainchoords,200,46),5)
        elif self.equipmen and not self.specific:
            pygame.draw.rect(globs.Surface,(255,0,0),(665+50*self.subchoords[0],390,50,50),5)
            globs.Surface.blit(graphic["gearselecter"],(230,480),(0,200*self.subchoords[0],685,200))
            pygame.draw.rect(globs.Surface,(255,0,0),(480,575+50*self.subchoords[1],200,46),5)
        elif self.equipmen and self.specific:
            if self.subchoords[0]  == 0:
                if self.gearscrolled == False:
                    self.scroll_gear("bodies")
                    self.equipping = "body"
            elif self.subchoords[0] == 1:
                if self.gearscrolled == False:
                    self.scroll_gear("heads")
                    self.equipping = "head"
            elif self.subchoords[0] == 2:
                if self.gearscrolled == False:
                    self.scroll_gear("armlegs")
                    self.equipping = "armleg"
            elif self.subchoords[0] == 3:
                if self.gearscrolled == False:
                    self.scroll_gear("weapons")
                    self.equipping = "weapon"
            elif self.subchoords[0] == 4:
                if self.gearscrolled == False:
                    self.scroll_gear("shields")
                    self.equipping = "shield"

            globs.Surface.blit(self.scrollshot,(362,580),(363,580,420,120))
            globs.Surface.blit(graphic["gearselecter"],(230,480),(0,1000,685,100))
            pygame.draw.rect(globs.Surface,(0,0,255),(372+50*self.specifchoords[0],590+50*self.specifchoords[1],50,50),5)


            globs.Surface.blit(basicFont.render(self.gear_dict[(self.specifchoords[0],self.specifchoords[1])].title,0,(0,0,255)),(450,480))
            globs.Surface.blit(midFont.render(self.gear_dict[(self.specifchoords[0],self.specifchoords[1])].descript,0,(0,0,0)),(250,540))

            self.gearstat_updates()


    def gearstat_updates(self):
            #inellegant as all hell and twice as functional... or something
            shorthand = self.gear_dict[(self.specifchoords[0],self.specifchoords[1])].stat_descript
            for i,stat in enumerate(shorthand):
                if i == 0: #comparing gear def stats
                    if stat > globs.Player.equipped[self.equipping].defen:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.defense+stat-globs.Player.equipped[self.equipping].defen),0,(0,255,0)),(845,115+60*i))
                    elif stat < globs.Player.equipped[self.equipping].defen:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.defense+stat-globs.Player.equipped[self.equipping].defen),0,(255,0,0)),(845,115+60*i))
                    else:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.defense),0,(0,0,255)),(845,115+60*i))
                elif i ==1 and self.equipping == "weapon": #comparing gear atk stats
                    #if other gears besides weapons effect atk this will need to be changed.
                    if stat > globs.Player.equipped[self.equipping].atk:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(stat),0,(0,255,0)),(845,115+60*i))
                    elif stat < globs.Player.equipped[self.equipping].atk:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(stat),0,(255,0,0)),(845,115+60*i))
                    else:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.weapon.atk),0,(0,0,255)),(845,115+60*i))
                elif i ==2: #comparing gear speed stats
                    if stat > globs.Player.equipped[self.equipping].speedPnlty:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.speed+stat-globs.Player.equipped[self.equipping].speedPnlty),0,(0,255,0)),(845,115+60*i))
                    elif stat < globs.Player.equipped[self.equipping].speedPnlty:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.speed+stat-globs.Player.equipped[self.equipping].speedPnlty),0,(255,0,0)),(845,115+60*i))
                    else:
                        globs.Surface.blit(graphic["campscreen"],(815,115+60*i),(615,115+60*i,100,50))
                        globs.Surface.blit(basicFont.render(str(globs.Player.speed),0,(0,0,255)),(845,115+60*i))


            
            

    def scroll_gear(self,kind):
        gear_surf = pygame.Surface((420,120)).convert()
        gear_surf.fill((255,0,255))
        self.gear_dict = {}
        for i,gear in enumerate(globs.Player.inventory["equipment"][kind]):
            if i < 8:
                gear_surf.blit(gear.display[0],(10+50*i,10))
                self.gear_dict[(i,0)] = gear
            else:
                gear_surf.blit(gear.display[0],(10+50*(i-8),10+50))
                self.gear_dict[(i-8,1)] = gear

        gear_surf.set_colorkey((255,0,255))

        gear_ready = pygame.Surface((420,120)).convert_alpha()
        gear_ready.fill((255,0,0),(8,8,404,130))
        pygame.draw.rect(gear_ready,(255,0,0),(0,0,420,130),5)
        gear_ready.blit(graphic["gearselecter"],(10,10),(0,1000,400,110))
        gear_ready.blit(gear_surf,(0,0))

        globs.Surface.blit(graphic["gearselecter"],(230,480),(0,1000,685,200))
        where = 0
        while 1:
            where += 2
            globs.Surface.blit(gear_ready,(362,700-where))
            pygame.display.update()
            pygame.time.delay(10)
            if where == 120: break

        pygame.event.clear()
        #event que is cleared after scrolling to avoid possible keyerrors.
        #This problem could also be solved with an exception handler perhaps more elegantly but more difficultly.
        #Previously a player could preemptively key in events while scrolling which was nice...  but a miss key or
        #keying to rapidly could cause an exception.
        #By clearing the event cue this problem is avoided, but pre-keying is now impossible.
        
        self.scrollshot = globs.Surface.copy()
        self.gearscrolled = True
            


##if __name__ == "__main__":
##    testcamp = BattleCamp()
##    testcamp.setitup()
##    globs.Surface.blit(testcamp.page,(200,0))
##    pygame.display.flip()
        

            
